using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using UnityEngine;
/// <summary>
/// /豸/ϵͳ
/// </summary>
public class D_Scheme
{
    #region 
    /// <summary>
    /// Id
    /// </summary>
    public int id;

    /// <summary>
    /// 
    /// </summary>
    public string schemeName;

    #endregion

    /// <summary>
    /// 
    /// </summary>
    public List<D_Process> processes =new List<D_Process>();

    /// <summary>
    /// ǰ
    /// </summary>
    private D_Process currentProcess;

    /// <summary>
    /// ǰ
    /// </summary>
    public D_Process CurrentProcess
    {
        get => currentProcess;
        set
        {
            currentProcess = value;
            CurrentProcessId = currentProcess.id;
        }
    }

    /// <summary>
    /// ǰid
    /// </summary>
    private int currentProcessId;

    /// <summary>
    /// ǰid
    /// </summary>
    public int CurrentProcessId 
    {
        get => currentProcessId;
        set 
        {
            currentProcessId = value;
            GameManager.ProcessMgr.processId = currentProcessId;
        }
    }

    /// <summary>
    /// ʼ
    /// </summary>
    public void Init() 
    {
        if (processes == null || processes.Count == 0) 
            return;
        CurrentProcess = processes[0];
        CurrentProcess.Init();
    }

    /// <summary>
    /// л
    /// </summary>
    public void HandoverProcess(int processId, int subProcessId, int subProcessStepId)
    {
        if (CurrentProcess != null)
            CurrentProcess.Exit();
        CurrentProcess = GetProcess(processId);
        CurrentProcess.Enter();
        UnityEngine.Debug.Log("л̵:" + processId);
        CurrentProcess.HandoverSubProcess(subProcessId, subProcessStepId);
        
    }

    /// <summary>
    /// idȡ ̶
    /// </summary>
    /// <param name="processId"></param>
    /// <returns></returns>
    private D_Process GetProcess(int processId) 
    {
        for (int i = 0; i < processes.Count; i++)
        {
            if (processes[i].id == processId)
            {
                return processes[i];
            }
        }
        return null;
    }
}
