using System.IO;
using UnityEngine;
using UnityEngine.Events;

public class NetManager : BaseManager<NetManager>
{
    private NetManager() { }

    /// <summary>
    /// ʵtoken
    /// </summary>
    public string token;

    public string url;

    /// <summary>
    /// ȡļ
    /// </summary>
    /// <param name="action"></param>
    public void GetConfig(UnityAction<bool> action) 
    {
        string path = Application.streamingAssetsPath + "/Config/Config.txt";
        Debug.Log(path);
        if (File.Exists(path))
        {
            Debug.Log(File.ReadAllText(path));
            url = File.ReadAllText(path);
            action?.Invoke(true);
        }
        else
        {
            Debug.Log("ûжӦļ");
            action?.Invoke(false);
            //UIManager.Instance.ShowPanel<UI_MessagePanel>(E_UI_Layer.System, (panel) =>
            //{
            //    panel.Init("ûжȡȷIpַļ,ĿStreamingAssetsļConfigļǷõַ˿ں!", E_MessageType.Error, Const.E_QuitApp);
            //});
        }

    }

    public void SaveInfo(string info) 
    {
        string path = Application.streamingAssetsPath + "/Config/info.txt";
        Debug.Log(path);
        File.WriteAllText(path, info);
    }
        

}
