using UnityEngine;

public class SingletonMono<T> : MonoBehaviour where T : MonoBehaviour
{
    private static T instance;

    public static T Instance
    {
        get => instance;
    }

    protected virtual void Awake()
    {
        //ѾһӦĵģʽ Ҫһ
        if (instance != null)
        {
            Destroy(this);
            return;
        }
        instance = this as T;
        //ǹؼ̳иõģʽĽű ĶʱͲᱻƳ
        //ͿԱ֤Ϸж 
        DontDestroyOnLoad(instance.gameObject);
    }
}
