using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;

public class ScenesManager : BaseManager<ScenesManager>
{
    private ScenesManager() { }
    /// <summary>
    /// ͬس
    /// </summary>
    /// <param name="sceneName"></param>
    /// <param name="action">غҪ</param>
    public void LoadScene(string sceneName, UnityAction action = null, LoadSceneMode loadSceneMode = LoadSceneMode.Single)
    {
        SceneManager.LoadScene(sceneName,loadSceneMode);
        action?.Invoke();
    }

    /// <summary>
    /// 첽س
    /// </summary>
    /// <param name="sceneName"></param>
    /// <param name="action">ί</param>
    /// <param name="loadSceneMode">سʽ</param>
    public void LoadSceneAsyn(string sceneName, UnityAction action = null,LoadSceneMode loadSceneMode = LoadSceneMode.Single)
    {
        MonoMgr.Instance.StartCoroutine(ReallyLoadScene(sceneName, action));
    }

    /// <summary>
    /// Э̼س
    /// </summary>
    /// <param name="sceneName"></param>
    /// <param name="action">ί</param>
    /// <param name="loadSceneMode">سʽ</param>
    /// <returns></returns>
    private IEnumerator ReallyLoadScene(string sceneName, UnityAction action = null, LoadSceneMode loadSceneMode = LoadSceneMode.Single)
    {
        AsyncOperation ao = SceneManager.LoadSceneAsync(sceneName, loadSceneMode);
        do
        {
            //ַ¼
            yield return ao.progress;
        } 
        while (!ao.isDone);
        action?.Invoke();
    }
}
