using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using UnityEngine;

/// <summary>
/// 
/// </summary>
public class D_Process : I_Enter, I_Exit
{
    #region 
    /// <summary>
    /// Id
    /// </summary>
    public int id;

    /// <summary>
    /// Id
    /// </summary>
    public int schemeId;

    /// <summary>
    /// 
    /// </summary>
    public string processName;

    #endregion


    /// <summary>
    /// ̵
    /// </summary>
    public List< D_SubProcess> subProcesses = new List<D_SubProcess>();

    /// <summary>
    /// ǰ
    /// </summary>
    private D_SubProcess currentSubProcess;

    /// <summary>
    /// ǰ
    /// </summary>
    public D_SubProcess CurrentSubProcess 
    { 
        get => currentSubProcess;
        set 
        {
            currentSubProcess = value;
            CurrentSubProcessId = currentSubProcess.id;
        }
    }

    /// <summary>
    /// ǰId
    /// </summary>
    private int currentSubProcessId;

    /// <summary>
    /// ǰId
    /// </summary>
    public int CurrentSubProcessId 
    {
        get => currentSubProcessId; 
        set 
        {
            currentSubProcessId = value;
            GameManager.ProcessMgr.subProcessId = currentSubProcessId;
        }
    }

    /// <summary>
    /// ʼ
    /// </summary>
    public void Init() 
    {
        if (subProcesses == null || subProcesses.Count == 0)
            return;
        CurrentSubProcess = subProcesses[0];
        CurrentSubProcess.Init();
    }

    /// <summary>
    /// л
    /// </summary>
    public void HandoverSubProcess(int subProcessId,int subProcessStepId)
    {
        if (CurrentSubProcess!= null)
        CurrentSubProcess.Exit();
        CurrentSubProcess = GetSubProcess(subProcessId);
        CurrentSubProcess.Enter();
        UnityEngine.Debug.Log("л̵:" + subProcessId);
        CurrentSubProcess.HandoverSubProcessStep(subProcessStepId);
    }

    /// <summary>
    /// idȡ ̶
    /// </summary>
    /// <param name="processId"></param>
    /// <returns></returns>
    private D_SubProcess GetSubProcess(int subProcessId)
    {
        for (int i = 0; i < subProcesses.Count; i++)
        {
            if (subProcesses[i].id == subProcessId)
            {
                return subProcesses[i];
            }
        }
        return null;
    }

    /// <summary>
    /// 
    /// </summary>
    public void Enter()
    {
        UnityEngine.Debug.Log("뵱ǰ:" + id + "_" + processName);
    }

    /// <summary>
    /// ˳
    /// </summary>
    public void Exit()
    {
        UnityEngine.Debug.Log("˳ǰ:" + id +"_" + processName);
    }
}
