using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using UnityEngine;
/// <summary>
/// 
/// </summary>
public class D_SubProcess : I_Enter, I_Exit
{

    #region 
    /// <summary>
    /// Id
    /// </summary>
    public int id;

    /// <summary>
    /// Id
    /// </summary>
    public int schemeId;

    /// <summary>
    /// id 
    /// </summary>
    public int processId;

    /// <summary>
    /// 
    /// </summary>
    public string subProcessName;

    /// <summary>
    /// Ƿǰ
    /// </summary>
    public bool isPrecondition;

    /// <summary>
    /// ǰ
    /// </summary>
    public string precondition;

    /// <summary>
    /// ʾ
    /// </summary>
    public string tips;
    #endregion

    /// <summary>
    /// ̵̲
    /// </summary>
    public List<D_SubProcessStep> subProcessStepes = new List<D_SubProcessStep>();

    /// <summary>
    /// ǰ̲
    /// </summary>
    private D_SubProcessStep currentSubProcessStep;

    /// <summary>
    /// ǰ̲
    /// </summary>
    public D_SubProcessStep CurrentSubProcessStep
    {
        get => currentSubProcessStep;
        set
        {
            currentSubProcessStep = value;
            CurrentSubProcessStepId = currentSubProcessStep.id;
        }
    }

    /// <summary>
    /// ǰ̲Id
    /// </summary>
    private int currentSubProcessStepId;

    /// <summary>
    /// ǰ̲Id
    /// </summary>
    public int CurrentSubProcessStepId
    {
        get => currentSubProcessStepId;
        set
        {
            currentSubProcessStepId = value;
            GameManager.ProcessMgr.subProcessStepId = currentSubProcessStepId;
        }
    }

    /// <summary>
    /// ʼ
    /// </summary>
    public void Init()
    {
        {
            if (subProcessStepes == null || subProcessStepes.Count == 0)
                return;
            CurrentSubProcessStep = subProcessStepes[0];
        }
    }

    /// <summary>
    /// л̲
    /// </summary>
    public void HandoverSubProcessStep(int stepId)
    {
        if (CurrentSubProcessStep != null)
            CurrentSubProcessStep.Exit();
        CurrentSubProcessStep = GetSubProcessStep(stepId);
        CurrentSubProcessStep.Enter();
        UnityEngine.Debug.Log("л̲赽:" + stepId);
    }

    /// <summary>
    /// idȡ ̶
    /// </summary>
    /// <param name="processId"></param>
    /// <returns></returns>
    private D_SubProcessStep GetSubProcessStep(int stepId)
    {
        for (int i = 0; i < subProcessStepes.Count; i++)
        {
            if (subProcessStepes[i].id == stepId)
            {
                return subProcessStepes[i];
            }
        }
        return null;
    }

    /// <summary>
    /// ˳
    /// </summary>
    public void Exit()
    {
        UnityEngine.Debug.Log("˳ǰ:" + id + "_" + subProcessName);
    }

    /// <summary>
    /// 
    /// </summary>
    public void Enter()
    {
        UnityEngine.Debug.Log("뵱ǰ:" + id + "_" + subProcessName);
    }
}
