using System.Runtime.InteropServices.ComTypes;
using UnityEngine;
/// <summary>
/// ͳһõ
/// </summary>
public class GameManager : SingletonAutoMono<GameManager>
{
    #region ײ
    /// <summary>
    /// Ui
    /// </summary>
    public static UIManager UIMgr { get; private set; }

    /// <summary>
    /// ¼
    /// </summary>
    public static EventCenter EventMgr { get; private set; }

    /// <summary>
    /// mono
    /// </summary>
    public static MonoMgr MonoMgr { get; private set; }

    /// <summary>
    /// ƹ
    /// </summary>
    public static BinaryManager BinaryMgr { get; private set; }

    /// <summary>
    /// json
    /// </summary>
    public static JsonManager JsonMgr { get; private set; }

    /// <summary>
    /// ع
    /// </summary>
    public static ScenesManager ScenesMgr { get; private set; }

    /// <summary>
    /// Դ
    /// </summary>
    public static ResourcesManager ResourcesMgr { get; private set; }

    /// <summary>
    /// Ч
    /// </summary>
    public static MusicManager MusicMgr { get; private set; }
    #endregion

    #region Ŀ
    /// <summary>
    /// ݹ
    /// </summary>
    public static DataManager DataMgr { get; private set; }

    /// <summary>
    /// ӿڹ
    /// </summary>
    public static NetManager NetMgr { get; private set; }

    /// <summary>
    /// ʵѵ̹
    /// </summary>
    public static ProcessManager ProcessMgr { get; private set; }

    /// <summary>
    /// 
    /// </summary>
    public static ReportManager ReportMgr { get; private set; }

    /// <summary>
    /// ʵѵ
    /// </summary>
    public static HandsOnTrainingMgr HandsOnTrainingMgr { get; private set; }
    #endregion

    /// <summary>
    /// ʼ
    /// </summary>
    public void Init()
    {

        UIMgr = UIManager.Instance;
        EventMgr = EventCenter.Instance;
        MonoMgr = MonoMgr.Instance;
        BinaryMgr = BinaryManager.Instance;
        JsonMgr = JsonManager.Instance;
        ScenesMgr = ScenesManager.Instance;
        ResourcesMgr = ResourcesManager.Instance;
        MusicMgr = MusicManager.Instance;

        DataMgr = DataManager.Instance;
        NetMgr = NetManager.Instance;
        ProcessMgr = ProcessManager.Instance;
        ReportMgr = ReportManager.Instance;
        HandsOnTrainingMgr = HandsOnTrainingMgr.Instance;

        UIMgr.ShowPanel<UI_LoadingPanel>(E_UI_Layer.System, (panel) =>
        {
            print("ʾҳ");
            panel.Init();
            EventMgr.EventTrigger<float>(Enum_EventType.UpdateProgress, 0.1f);
            //رļ 
            //ʼû ģʽ tokenȱҪ
            //ȡɹ ȡģʽ ģʽʾʼҳ
            NetMgr.GetConfig((isSuccess) =>
            {
                if (isSuccess)
                {
                    DataMgr.Init();
                    //ȡɹ ȡģʽ ģʽʾʼҳ
                    //ǷΪģʽ ȫԱ
                    if (!true)
                    {

                    }
                    else
                    {
                        EventMgr.EventTrigger<float>(Enum_EventType.UpdateProgress, 0.2f);
                        //ʾUI˵б
                        UIMgr.ShowPanel<UI_SelectModePanel>(E_UI_Layer.Mid, panel =>
                        {
                            EventMgr.EventTrigger<float>(Enum_EventType.UpdateProgress, 0.2f);
                            panel.Init();
                        });

                        //س /ʾUI
                        ScenesMgr.LoadSceneAsyn("02_MenuScene", () =>
                        {
                            //޸ıļ
                            NetMgr.SaveInfo("1");
                            EventMgr.EventTrigger<float>(Enum_EventType.UpdateProgress, 0.5f);
                        });
                    }
                }
                else
                {
                    //ȡʧ ʾϢ˳Ӧ
                }
            });
        });
    }

    public void End() 
    {
        //޸ıļ
        NetMgr.SaveInfo("0");
        //˳Ӧ
        Application.Quit();

    }
}
