using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using LitJson;
using System.IO;

/// <summary>
/// ʹ
/// </summary>
public enum JsonType
{
    /// <summary>
    /// 
    /// </summary>
    LitJson,
    /// <summary>
    /// ϵͳԴ
    /// </summary>
    JsonUtility,
}


/// <summary>
/// Jsonݴ  ڴJson
/// UnityԴjsonJsonUtility 
///     ֵ֧
///     ԶҪ[System.Serializable]
///     private protected Ҫл Ҫ[SerializeField]
///     ֱӶȡ
/// ǳLitJson
///     ֧˽б
///     JsonDataȡ ֶ
///     ֵҪʹ string
///     ԶҪʹ ޲ι캯
///     ıʽUTF-8
/// </summary>
public class JsonManager : BaseManager<JsonManager>
{
    private JsonManager() { }

    /// <summary>
    ///  PC
    /// </summary>
    /// <param name="data">Ҫ洢ݶ</param>
    /// <param name="fileName">洢Ϊļ</param>
    /// <param name="type">洢ʽĬLitJson</param>
    public void SaveData(object data ,string fileName,JsonType type = JsonType.LitJson)
    {
        //洢·
        string path = Application.persistentDataPath + "/" + fileName + ".json";
        //л õjsonַ
        string json = "";
        switch (type)
        {
            case JsonType.LitJson:
                json = JsonMapper.ToJson(data);
                break;
            case JsonType.JsonUtility:
                json = JsonUtility.ToJson(data);
                break;
        }
        //jsonַļ
        File.WriteAllText(path, json);
    }

    /// <summary>
    /// ȡ PC
    /// </summary>
    /// <typeparam name="T"></typeparam>
    /// <param name="path"></param>
    /// <returns></returns>
    public T LoadData<T>(string fileName,JsonType type = JsonType.LitJson) where T : new()
    {
        //·
        string path = Application.streamingAssetsPath + "/" + fileName + ".json";
        if (!File.Exists(path))
        {
            path = Application.persistentDataPath + "/" + fileName + ".json";
        }
        if (!File.Exists(path))
        {
            return new T();
        }
        //ȡjsonַ
        string jsonStr = File.ReadAllText(path);

        //
        T data = new T();
        //
        switch (type)
        {
            case JsonType.LitJson:
                data = JsonMapper.ToObject<T>(jsonStr);
                break;
            case JsonType.JsonUtility:
                data = JsonUtility.FromJson<T>(jsonStr);
                break;
        }
        return data;
    }
}
